@echo off
rem Installs Care Management onto a workstation
rem not a very elegant script since it doesn't check every error
rem condition but well it's a batch file
rem first call the settings.bat command

rem this changes the current directory to the directory from which I've been called
set BASEDIR=%~p0
cd %BASEDIR%
rem Let's check for settings.bat
if not exist etc\settings.bat goto :nosettingserror

:start
call etc\settings
if "%VAULTIP%"=="1.2.3.4" goto :noediterror

rem Install Sentillion Desktop Components
%CHECKSENTILLION%
if errorlevel 1 goto :sentillion 
if errorlevel 0 goto :java

:sentillion
echo "Installing Sentillion..."
start /B /WAIT %SENTILLIONDIR%\setup.exe -s -f1=%SENTILLIONDIR%\setup.iss
:wait
%SLEEP% 10
%CHECKSENTILLION%
if errorlevel 1 goto :wait

:java
echo "Installing Java if needed"
%CHECKJAVA%
if ERRORLEVEL==1 start /B /WAIT %JAVAINSTALLEXE% /s /v"/qn ADDLOCAL=jrecore"
%SLEEP% 2
%CHECKJAVA%
if errorlevel 1 goto :javaerror

:hevd
echo Copying the .exe file
if not exist "%INSTALLDIR%" mkdir "%INSTALLDIR%"
copy %HEALTHEVET% "%INSTALLDIR%\"

pushd %INSTALLDIR%
echo Doing Silent pull of Desktop Plugins
"%INSTALLDIR%\%HEALTHEVETEXE%" -silent "%CONFIGPATH%"
if not exist "%INSTALLDIR%\plugins" goto :pullerror

popd

echo Creating HealtheVet Desktop Shortcuts
start /B /WAIT %SHORTCUT% /A:C /F:"%INSTALLDIR%\%SHORTCUTNAME%.lnk" /W:"%INSTALLDIR%" /T:"%INSTALLDIR%\%HEALTHEVETEXE%" /P:""%CONFIGPATH%""
start /B /WAIT %SHORTCUT% /A:C /F:"%SHORTCUTDESKTOP%\%SHORTCUTNAME%.lnk" /T:"%INSTALLDIR%\%SHORTCUTNAME%"
start /B /WAIT %SHORTCUT% /A:C /F:"%SHORTCUTSTARTMENU%\%SHORTCUTNAME%.lnk" /T:"%INSTALLDIR%\%SHORTCUTNAME%"


goto :exit

:pullerror
echo ERROR
echo After attempting a pull of the Healthevet Desktop plugins
echo there still don't seem to be plugins there
echo so I'm bailing out.
goto :exiterror

:javaerror
echo ERROR
echo I tried to install Java, but it didn't seem to install correctly.
echo You may need to install the Java VM manually and 
echo see if there are any error messages"
goto :exiterror

:noediterror
echo ERROR
echo "You don't appear to have edited the settings.bat file."
echo "Please do so with the correct vault IP and path to your config file"
goto :exiterror


:nosettingserror
rem if we got called from a UNC, this may do the trick
pushd \\%BASEDIR%
if exist etc\settings.bat goto :start
rem if it's still not there, time to bail out
echo ERROR
echo I tried to find the settings.bat file we need for
echo The install, but I couldn't read it.
echo This may be because you tried to launch me from a 
echo directory that wasn't mapped to a drive letter or
echo because your settings.bat was accidentally 
echo renamed as settings.bat.txt after it was edited
goto :exiterror


:exiterror
echo Exiting due to errors...
pause
:exit
